# Copyright 2006 TBD / plugins.ro 

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          Centroid 1.0
# Description :   add a cpoint at gravity center for a 2D face 
# Author :        TBD
# Date :          26.Sep.2006
# Type :          tool
# History:        1.0 (26.Sep.2006) - first version

require 'sketchup.rb'

class Centroid
  def self.go
    f = Sketchup.active_model.selection[0]
    a = f.area 
    v = f.vertices.map {|x| x.position.to_a}
    
    cx = cy = 0
    
    for i in 0..v.length-2
      second = (v[i].x * v[i+1].y) - (v[i+1].x * v[i].y)
      cx += (v[i].x + v[i+1].x) * second
      cy += (v[i].y + v[i+1].y) * second
    end
    
    cx = -cx / 6.0 / a
    cy = -cy / 6.0 / a
    
    Sketchup.active_model.active_entities.add_cpoint [cx,cy]
  end
end
  
if( not file_loaded?("centroid.rb") )
  centroid_menu = UI.menu("Plugins").add_item("[TBD] Centroid") {Centroid.go}
end

file_loaded("centroid.rb")
